// TestRichEditMFCDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "TestRichEditMFC.h"
#include "TestRichEditMFCDlg.h"
#include "RichEditHelper.h"
#include "ScreenCaptureWrapper.h"

#pragma warning(disable:4482)
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define WM_MY_MSG_SCREENNOTICE  WM_USER + 111
#define WM_MY_MSG_NOTICEADDWELCOMEMSG WM_USER + 112




class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestRichEditMFCDlg Ի




CTestRichEditMFCDlg::CTestRichEditMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestRichEditMFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestRichEditMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RICHEDIT21, m_richRecord);
	DDX_Control(pDX, IDC_RICHEDIT22, m_richSend);
	DDX_Control(pDX, IDC_BUTTON_EMOTION, m_btn_Emotion);
}

BEGIN_MESSAGE_MAP(CTestRichEditMFCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_INSERTIMAGE, &CTestRichEditMFCDlg::OnBnClickedButtonInsertimage)
	ON_BN_CLICKED(IDC_BUTTON_GETCONTENT, &CTestRichEditMFCDlg::OnBnClickedButtonGetcontent)
	ON_BN_CLICKED(IDC_BUTTON_EMOTION, &CTestRichEditMFCDlg::OnBnClickedButtonEmotion)
	ON_WM_ACTIVATE()
	ON_BN_CLICKED(IDC_BUTTON_SCREENSHOT, &CTestRichEditMFCDlg::OnBnClickedButtonScreenshot)
END_MESSAGE_MAP()


// CTestRichEditMFCDlg Ϣ

BOOL CTestRichEditMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	CRichEditHelper::m_fnInitRichEditWnd(m_hWnd, m_richRecord.m_hWnd);
	CRichEditHelper::m_fnInitRichEditWnd(m_hWnd, m_richSend.m_hWnd);
	
	CRichEditHelper::m_fnSetDefaultFont(m_richRecord.m_hWnd, _T("΢ź"), 12, RGB(0, 0, 0), FALSE, FALSE, FALSE, FALSE);
	CRichEditHelper::m_fnSetDefaultFont(m_richSend.m_hWnd, _T("΢ź"), 12, RGB(0, 0, 0), FALSE, FALSE, FALSE, FALSE);

	

	CString strEmotionUrl = CRichEditHelper::GetCurrentPath().c_str();
	strEmotionUrl += "Emotion\\face.htm";
	m_emotionDlg.Create(IDD_DIALOG_EMOTION, NULL);
	m_emotionDlg.SetInfo(this, strEmotionUrl);
	m_emotionDlg.ShowWindow(SW_HIDE);



	//ʼͼ 
	CScreenCaptureWrapper::InitCapture(_T("niuniu"), _T(""));
	CScreenCaptureWrapper::InitParam(ExtendFlagTypeEnum::emPensize, 2);	//߿
	CScreenCaptureWrapper::InitParam(ExtendFlagTypeEnum::emDrawType, 0);	//÷Ŵ󾵷0 Ѷ   1 360 
	CScreenCaptureWrapper::InitParam(ExtendFlagTypeEnum::emTrackColor, RGB(255, 0, 0));	//Զʶı߿ɫ
	CScreenCaptureWrapper::InitParam(ExtendFlagTypeEnum::emEditBorderColor, RGB(0, 174, 255));	//ֱ༭߿ɫ
	CScreenCaptureWrapper::InitParam(ExtendFlagTypeEnum::emTransparent, 240); //ù͸

	
	m_richSend.SetFocus();
	PostMessage(WM_MY_MSG_NOTICEADDWELCOMEMSG);
	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CTestRichEditMFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CTestRichEditMFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡùʾ
//
HCURSOR CTestRichEditMFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

#define	EN_PASTE	0x0800	// ճϢ

LRESULT CTestRichEditMFCDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message == WM_NOTIFY)
	{
		LPNMHDR pDr = (LPNMHDR)lParam;
		if (EN_PASTE == pDr->code)
		{
			if (pDr->hwndFrom == m_richSend.m_hWnd)
			{
				CRichEditHelper::m_fnAddPasteMsg(m_richSend.m_hWnd, (LPVOID)lParam);
			}
		}
		else if(EN_LINK == pDr->code)
		{
			ENLINK *pLink = (ENLINK *) lParam;
			if (pLink->msg == WM_LBUTTONDOWN)
			{				
				HWND hwnd = pDr->hwndFrom;
				map<int, CString>::iterator it = m_dicStringUrl.find(pLink->chrg.cpMin);
				CString strUrl = _T("");
				if (it != m_dicStringUrl.end())
				{
					strUrl = it->second;
				}
				else
				{
					strUrl = CRichEditHelper::m_fnGetSelText(hwnd, pLink->chrg.cpMin, pLink->chrg.cpMax);
				}
				
				HINSTANCE hInstance = ::ShellExecute(NULL, _T("open"), _T("iexplore.exe"), strUrl, NULL, SW_SHOWMAXIMIZED);
			}
		}
		
	}

	if (message == WM_MY_MSG_SCREENNOTICE)
	{
		CRichEditHelper::m_fnInsertImage(m_richSend.m_hWnd, m_strDefaultPath.c_str());
	}

	if(message == WM_MY_MSG_NOTICEADDWELCOMEMSG)
	{
		AddWelcomeMsg();
	}
	return __super::DefWindowProc(message, wParam, lParam);
}

void CTestRichEditMFCDlg::OnBnClickedButtonInsertimage()
{
	// _T("PNG (*.png)|*.png|BMP (*.bmp)|*.bmp|JPG (*.jpg;*.jpeg)|*.jpg;*.jpeg||")
	CFileDialog dlg(TRUE, _T(""), _T(""), OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, _T("PNG (*.png)|*.png|BMP (*.bmp)|*.bmp|JPG (*.jpg;*.jpeg)|*.jpg;*.jpeg|GIF (*.gif)|*.gif||"), this);
	dlg.m_ofn.lpstrInitialDir = _T("");
	dlg.m_ofn.nMaxFile = MAX_PATH;			
	if (IDOK == dlg.DoModal())
	{
		CString curPathName = dlg.GetPathName();
		CString curFilename = dlg.GetFileName();
		CRichEditHelper::m_fnInsertImage(m_richSend.m_hWnd, curPathName);
	}	
}

void CTestRichEditMFCDlg::OnBnClickedButtonGetcontent()
{
	CString strContent = CRichEditHelper::m_fnGetRichTextContent(m_richSend.m_hWnd);
	AddMsgToRecord(strContent);
	m_richSend.SetWindowText(_T(""));
	m_richSend.SetFocus();
}

void CTestRichEditMFCDlg::AddMsgToRecord(LPCTSTR lpText)
{
	if (NULL == lpText || NULL == *lpText)
		return;
	
	m_richRecord.SetSel(-1, -1);

	CString strTitle = _T("");
	strTitle.Format(_T("ţţ %s:\r\n"), CTime::GetCurrentTime().Format(_T("%H:%M:%S")));
	
	CRichEditHelper::m_fnReplaceSel(m_richRecord.m_hWnd, strTitle, _T("΢ź"), 12, RGB(255, 0, 0), TRUE, FALSE, FALSE, FALSE, 0);
	
	CRichEditHelper::m_fnSetStartIndent(m_richRecord.m_hWnd, 350);

	CRichEditHelper::m_fnAppendMsg(m_richRecord.m_hWnd, lpText);
	CRichEditHelper::m_fnAppendMsg(m_richRecord.m_hWnd, _T("\r\n"));
	CRichEditHelper::m_fnSetStartIndent(m_richRecord.m_hWnd, 0);
	m_richRecord.PostMessage(WM_VSCROLL, SB_BOTTOM, 0);
}

BOOL CTestRichEditMFCDlg::PreTranslateMessage(MSG* pMsg)
{
	try
	{
		if (pMsg->message == WM_KEYDOWN)
		{
			if(pMsg->wParam == VK_RETURN)
			{
				if(pMsg->hwnd == ::GetDlgItem(m_hWnd, IDC_RICHEDIT22))
				{
					OnBnClickedButtonGetcontent();
				}
				return TRUE;
			}
			if(pMsg->wParam == VK_ESCAPE)
			{
				return TRUE;
			}
		}
	}
	catch(...)
	{
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CTestRichEditMFCDlg::OnBnClickedButtonEmotion()
{
	CRect rect;
	m_btn_Emotion.GetWindowRect(&rect);
	int nLeft = rect.left;
	int nTop = rect.top;

	

 	m_emotionDlg.MoveWindow(rect.left, rect.top - 157, 266, 156);
	m_emotionDlg.SetForegroundWindow(); 
	m_emotionDlg.ShowWindow(SW_SHOWNORMAL); 
}

void CTestRichEditMFCDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);

	if (::IsWindow(m_emotionDlg.GetSafeHwnd()))
	{
		m_emotionDlg.ShowWindow(SW_HIDE);
	}
}

void CTestRichEditMFCDlg::OnSelectEmotion(int lParam)
{
	m_emotionDlg.ShowWindow(SW_HIDE);
	CString strEmotionPath;
	strEmotionPath.Format(_T("%sEmotion\\%d.gif"), CRichEditHelper::GetCurrentPath().c_str(), lParam);
	CRichEditHelper::m_fnInsertImage(m_richSend.m_hWnd, strEmotionPath);
	m_richSend.SetFocus();
}

void CTestRichEditMFCDlg::OnBnClickedButtonScreenshot()
{
	m_strDefaultPath = CScreenCaptureWrapper::GetDefaultSavePath();
	m_strDefaultPath += _T("\\TestCapture\\");

	::CreateDirectory(m_strDefaultPath.c_str(), NULL);

	CString strPath;
	strPath.Format(_T("img%ld.png"), GetTickCount());

	m_strDefaultPath += (LPCTSTR)strPath;
	CScreenCaptureWrapper::DoCapture(m_strDefaultPath.c_str(), NULL, (UINT_PTR)m_hWnd, WM_MY_MSG_SCREENNOTICE, NULL, 0, 0, 0, 0, 0);
}

void CTestRichEditMFCDlg::AddWelcomeMsg()
{	
	CString strText = _T("ӭʹNiuniuRichEditؼҳ롰");

	CRichEditHelper::m_fnReplaceSel(m_richRecord.m_hWnd, strText, _T("΢ź"), 12, RGB(255, 0, 0), TRUE, FALSE, FALSE, FALSE, 0);

	CString strContent = CRichEditHelper::m_fnGetRichTextContent(m_richRecord.m_hWnd);
	int nStartPos = strContent.GetLength();
	m_dicStringUrl[nStartPos] = _T("http://www.ggniu.cn/?from=4");
	strText = _T("");
	CRichEditHelper::m_fnReplaceSel(m_richRecord.m_hWnd, strText, _T("΢ź"), 12, RGB(255, 0, 0), TRUE, FALSE, FALSE, TRUE, 0);

	strText = _T("");
	CRichEditHelper::m_fnReplaceSel(m_richRecord.m_hWnd, strText, _T("΢ź"), 12, RGB(255, 0, 0), TRUE, FALSE, FALSE, FALSE, 0);
	CRichEditHelper::m_fnAppendMsg(m_richRecord.m_hWnd, _T("\r\n"));
	m_richSend.SetFocus();
}
