using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplicationRichEditTest
{
    [System.Runtime.InteropServices.ComVisibleAttribute(true)] 
    public partial class EmotionDlg : Form
    {
        public IEmotionSelected m_emotion;
        public EmotionDlg()
        {
            InitializeComponent();
        }

        private void EmotionDlg_Load(object sender, EventArgs e)
        {
            this.webBrowser1.ObjectForScripting = this;
            string strUrl = System.AppDomain.CurrentDomain.BaseDirectory + "Emotion\\face.htm";
            webBrowser1.Navigate(strUrl);
            this.Size = new Size(266, 156);
        }

        private void EmotionDlg_Deactivate(object sender, EventArgs e)
        {
            Hide();
        }

        public void SelectEmotion(int nID)
        {
            m_emotion.OnEmotionSelected(nID);
            Hide();
        }
    }
}