using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Drawing;

namespace WindowsApplicationRichEditTest
{    
    enum ExtendFlagTypeEnum
    {
	    emPensize = 1,		//ûʴС
	    emDrawType,			//Ѷ360
	    emTrackColor,		//Զʶı߿ɫ
	    emEditBorderColor,	//ıı߿ɫ
	    emTransparent,		//͸
	    emWindowAware,		//ǷDPIŴ
	    emDetectSubWindowRect,	//ǷԶӴڣʱ 
	    emSetSaveName,		//ñʱĿʼ
	    emSetMagnifierBkColor, //÷Ŵ󾵵ıɫ͸
	    emSetMagnifierLogoText, //÷ŴϵLOGOַʾݼ磺 ţţͼ(CTRL + SHIFT + A)
    };

    public class ScreenCaptureWrapper
    {
        [DllImport("NiuniuCapture.dll")]
        public static extern int InitCaptureParamW(int flag, UIntPtr flagvalue);

        [DllImport("NiuniuCapture.dll")]
        public static extern int InitScreenCaptureW([MarshalAs(UnmanagedType.LPWStr)]string szAuth);

        [DllImport("NiuniuCapture.dll")]
        public static extern int StartScreenCaptureW([MarshalAs(UnmanagedType.LPWStr)]string szDefaultSavePath, IntPtr pCallBack,
                    IntPtr hWndNotice, UIntPtr noticeMsg, IntPtr hwndHideWhenCapture, int autoCapture, int x, int y, int width, int height);

        private static UInt32 ToRGB(Color color)
        {
            int nColor = color.ToArgb();

            int blue = nColor & 255;

            int green = nColor >> 8 & 255;

            int red = nColor >> 16 & 255;

            return ToRGB(red, green, blue);
        }

        private static UInt32 ToRGB(int red, int green, int blue)
        {
            return Convert.ToUInt32(blue << 16 | green << 8 | red);
        }

        public static void Init()
        {
            InitScreenCaptureW("niuniu");

		    InitCaptureParamW((int)ExtendFlagTypeEnum.emPensize, (UIntPtr)2);	//߿
            InitCaptureParamW((int)ExtendFlagTypeEnum.emDrawType, (UIntPtr)0);	//÷Ŵ󾵷0 Ѷ   1 360 
            InitCaptureParamW((int)ExtendFlagTypeEnum.emTrackColor, (UIntPtr)ToRGB(255, 0, 0));	//Զʶı߿ɫ
            InitCaptureParamW((int)ExtendFlagTypeEnum.emEditBorderColor, (UIntPtr)ToRGB(0, 174, 255));	//ֱ༭߿ɫ
            InitCaptureParamW((int)ExtendFlagTypeEnum.emTransparent, (UIntPtr)240); //ù͸

		    //string szSavePath = UnicodeToAnsi("ţţͼ");
            // InitCaptureParam(ExtendFlagTypeEnum.emSetSaveName, (UINT_PTR)szSavePath.); //ñʱĿʼ
		    //gl_InitCaptureParam(ExtendFlagTypeEnum.emSetMagnifierBkColor, RGB(255, 255, 255)); //÷Ŵ󾵵ıɫ͸

            InitCaptureParamW((int)ExtendFlagTypeEnum.emWindowAware, (UIntPtr)1); //˺贰ڴǰãͬ´
        }

        public static string get_uft8(string unicodeString)
        {
            UTF8Encoding utf8 = new UTF8Encoding();
            Byte[] encodedBytes = utf8.GetBytes(unicodeString);
            String decodedString = utf8.GetString(encodedBytes);
            return decodedString;
        }

    }
}
